<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (6)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
  </head>
  <body>
    <h1 id="code-structure">Code structure</h1>
    <p>The first thing we’ll study is the building blocks of code.</p>
    <h2 id="statements">Statements</h2>
    <p>Statements are syntax constructs and commands that perform actions.</p>
    <p>
      We’ve already seen a statement, <code>alert('Hello, world!')</code>, which
      shows the message “Hello, world!”.
    </p>
    <p>
      We can have as many statements in our code as we want. Statements can be
      separated with a semicolon.
    </p>
    <p>For example, here we split “Hello World” into two alerts:</p>
    <p><code>js run no-beautify alert("Hello"); alert("World");</code></p>
    <p>
      Usually, statements are written on separate lines to make the code more
      readable:
    </p>
    <p><code>js run no-beautify alert("Hello"); alert("World");</code></p>
    <h2 id="semicolons-semicolon">Semicolons [#semicolon]</h2>
    <p>A semicolon may be omitted in most cases when a line break exists.</p>
    <p>This would also work:</p>
    <p><code>js run no-beautify alert("Hello"); alert("World");</code></p>
    <p>
      Here, JavaScript interprets the line break as an “implicit” semicolon.
      This is called an
      <a
        href="https://tc39.github.io/ecma262/#sec-automatic-semicolon-insertion"
        >automatic semicolon insertion</a
      >.
    </p>
    <p>
      <strong
        >In most cases, a newline implies a semicolon. But “in most cases” does
        not mean “always”!</strong
      >
    </p>
    <p>
      There are cases when a newline does not mean a semicolon. For example:
    </p>
    <p><code>js run no-beautify alert(3 + 1 + 2);</code></p>
    <p>
      The code outputs <code>6</code> because JavaScript does not insert
      semicolons here. It is intuitively obvious that if the line ends with a
      plus <code>"+"</code>, then it is an “incomplete expression”, so the
      semicolon is not required. And in this case that works as intended.
    </p>
    <p>
      <strong
        >But there are situations where JavaScript “fails” to assume a semicolon
        where it is really needed.</strong
      >
    </p>
    <p>Errors which occur in such cases are quite hard to find and fix.</p>
    <p>
      ````smart header=“An example of an error” If you’re curious to see a
      concrete example of such an error, check this code out:
    </p>
    <p><code>js run [1, 2].forEach(alert)</code></p>
    <p>
      No need to think about the meaning of the brackets <code>[]</code> and
      <code>forEach</code> yet. We’ll study them later. For now, just remember
      the result of the code: it shows <code>1</code> then <code>2</code>.
    </p>
    <p>
      Now, let’s add an <code>alert</code> before the code and
      <em>not</em> finish it with a semicolon:
    </p>
    <p>```js run no-beautify alert(“There will be an error”)</p>
    <p>[1, 2].forEach(alert) ```</p>
    <p>
      Now if we run the code, only the first <code>alert</code> is shown and
      then we have an error!
    </p>
    <p>
      But everything is fine again if we add a semicolon after
      <code>alert</code>: ```js run alert(“All fine now”);
    </p>
    <p>[1, 2].forEach(alert) ```</p>
    <p>
      Now we have the “All fine now” message followed by <code>1</code> and
      <code>2</code>.
    </p>
    <p>
      The error in the no-semicolon variant occurs because JavaScript does not
      assume a semicolon before square brackets <code>[...]</code>.
    </p>
    <p>
      So, because the semicolon is not auto-inserted, the code in the first
      example is treated as a single statement. Here’s how the engine sees it:
    </p>
    <p>
      <code
        >js run no-beautify alert("There will be an error")[1,
        2].forEach(alert)</code
      >
    </p>
    <p>
      But it should be two separate statements, not one. Such a merging in this
      case is just wrong, hence the error. This can happen in other situations.
      ````
    </p>
    <p>
      We recommend putting semicolons between statements even if they are
      separated by newlines. This rule is widely adopted by the community. Let’s
      note once again – <em>it is possible</em> to leave out semicolons most of
      the time. But it’s safer – especially for a beginner – to use them.
    </p>
    <h2 id="comments-code-comments">Comments [#code-comments]</h2>
    <p>
      As time goes on, programs become more and more complex. It becomes
      necessary to add <em>comments</em> which describe what the code does and
      why.
    </p>
    <p>
      Comments can be put into any place of a script. They don’t affect its
      execution because the engine simply ignores them.
    </p>
    <p>
      <strong
        >One-line comments start with two forward slash characters
        <code>//</code>.</strong
      >
    </p>
    <p>
      The rest of the line is a comment. It may occupy a full line of its own or
      follow a statement.
    </p>
    <p>Like here:</p>
    <p>```js run // This comment occupies a line of its own alert(“Hello”);</p>
    <p>alert(“World”); // This comment follows the statement ```</p>
    <p>
      <strong
        >Multiline comments start with a forward slash and an asterisk
        <code>/*</code> and end with an asterisk and a forward slash
        <code>*/</code>.</strong
      >
    </p>
    <p>Like this:</p>
    <p>
      <code
        >js run /* An example with two messages. This is a multiline comment. */
        alert("Hello"); alert("World");</code
      >
    </p>
    <p>
      The content of comments is ignored, so if we put code inside
      <code>/* … */</code>, it won’t execute.
    </p>
    <p>Sometimes it can be handy to temporarily disable a part of code:</p>
    <p>
      <code
        >js run /* Commenting out the code alert('Hello'); */
        alert("World");</code
      >
    </p>
    <p>
      <code
        >smart header="Use hotkeys!" In most editors, a line of code can be
        commented out by pressing the `key:Ctrl+/` hotkey for a single-line
        comment and something like `key:Ctrl+Shift+/` -- for multiline comments
        (select a piece of code and press the hotkey). For Mac, try `key:Cmd`
        instead of `key:Ctrl` and `key:Option` instead of `key:Shift`.</code
      >
    </p>
    <p>
      ```<code
        >warn header="Nested comments are not supported!" There may not be</code
      >/<em>…</em>/<code>inside another</code>/<em>…</em>/`.
    </p>
    <p>Such code will die with an error:</p>
    <p>
      <code
        >js run no-beautify /* /* nested comment ?!? */ */ alert( 'World'
        );</code
      >
      ````
    </p>
    <p>Please, don’t hesitate to comment your code.</p>
    <p>
      Comments increase the overall code footprint, but that’s not a problem at
      all. There are many tools which minify code before publishing to a
      production server. They remove comments, so they don’t appear in the
      working scripts. Therefore, comments do not have negative effects on
      production at all.
    </p>
    <p>
      Later in the tutorial there will be a chapter
      <a href="info:code-quality" class="uri">info:code-quality</a> that also
      explains how to write better comments.
    </p>
  </body>
</html>
